<?php
/*
Plugin Name:  Flipper
Plugin URI: http://www.vjcatkick.com/?page_id=
Description: Add HTML tag for flip open/close section.
Version: 0.0.3
Author: V.J.Catkick
Author URI: http://www.vjcatkick.com/
*/

/*
License: GPL
Compatibility: WordPress 2.6 with Widget-plugin.

Installation:
Place the widget_single_photo folder in your /wp-content/plugins/ directory
and activate through the administration panel, and then go to the widget panel and
drag it to where you would like to have it!
*/

/*  Copyright V.J.Catkick - http://www.vjcatkick.com/

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/* Changelog
* Oct 16 2010 - v0.0.1
- Initial release
* Oct 16 2010 - v0.0.2
- bug fix
* Oct 17 2010 - v0.0.3
- bug fix
*/

function make_flipper_callback( $matches ) {
	$src_text = $matches[0];
	$output = '';
	global $post;
	$unique_id = rand();
	$pid = $post->ID;

	$unique_id_str = $pid . '-' . $unique_id;

	$option_default_status = 'block';

	// first, get option string
	$r = preg_match( '/<flipper>|<flipper(.+?)>/s', $src_text, $option_str );
	if( $r > 0  ) {
		$is_default_flip_status = preg_match( '/display((.*?)=(.*?))(\"|\')(none|block)(.*?)(\"|\')/s', $option_str[1], $default_flip_status_str );
		if( $is_default_flip_status > 0 ) {
			if( preg_match( '/block/s', $default_flip_status_str[0], $m ) > 0 ) $option_default_status = 'block';
			else if( preg_match( '/none/s', $default_flip_status_str[0], $m ) > 0 ) $option_default_status = 'none';
		} /* if */
	} /* if */

	preg_match(  '/<\/flipper>|<\/flipper(.+?)>/s', $src_text, $mm );
	$src_text = preg_replace( '/<\/flipper>|<\/flipper(.+?)>/s', "\n</flipper>", $src_text );

	// separate parts
	$result_str = '';
//	$raw_str = strip_tags( $src_text );
	$src_text = preg_replace( '/<flipper>|<flipper(.+?)>/s', '', $src_text );
	$src_text = preg_replace( '/<\/flipper>|<\/flipper(.+?)>/s', '', $src_text );

	$raw_str = $src_text;
	$r = preg_match_all( '/(.*?)\n/s', $raw_str, $m2 );

	// 0.0.3 - check CRLF or BR at top of list
	$data_array = $m2[1];
	foreach( $data_array as $v ) {
		if( !preg_match( '/(<br>|<br\/>|<br \/>)|\n/is', $v, $mt ) ) {
			break;
		}else{
			array_shift( $data_array );
		} /* if else */
	} /* foreach */

	if( $r > 0 ) {
		$titled = false;
		$result_str .= '<div id="flipper_wap" >';
		foreach( $data_array as $v ) {
			if( !$titled ) {
				if( mb_strlen( $v ) >= 1 ) {
					$result_str .= '<div class="flipper_title" style="cursor: pointer;" onclick="flipper_title_clicked( \'' . $unique_id_str . '\' ); " >';
					$result_str .= $v;
					$result_str .= '</div><!-- flipper_title -->';

					$result_str .= '<div class="flipper_contents p_id-' . $pid . '" id="' . $unique_id_str . '" style="display: ' . $option_default_status . ';" >';
					$titled = true;
				} /* if */
			}else if( $titled ) {
				if( strlen( $v ) > 0 ) $result_str .= $v;
//				$result_str .= '<br />';		// 0.0.3 - fix
			} /* if else */
		} /* foreach */
		$result_str .= '</div><!-- flipper_contents -->';
		$result_str .= '</div><!-- flipper_wap -->';
	} /* if */
	$output .= $result_str;


	$jscode = '
<script type="text/javascript" >
function flipper_title_clicked( flipper_id ) {
	var element = document.getElementById( flipper_id );
	 if( element ) { 
	 	if( element.style.display == "block" ) element.style.display = "none";
		 else element.style.display = "block";
	}
}
</script>';
	$output .= $jscode;


	return( $output );
} /* make_flipper_callback() */

function make_flipper_all_callback( $matches ) {
	$src_text = $matches[0];
	$output = '';
	global $post;
	$pid = $post->ID;

	$output .= preg_replace( '/<flipper_all>/s', '<flipper_all class="flipper_all" onclick="flipper_flip_all( ' . $pid . ' ); " style="cursor: pointer;" >', $src_text );

	$jscode = '
<script type="text/javascript" >
function flipper_flip_all( p_id ) {
	var elements = document.getElementsByTagName( "div" );
	 if( elements.length > 0 ) { 
		var newFlipperValue = "";
		for( i=0; i < elements.length; i++ ) {
			var theName = elements[i].className;
			if( theName.length > 0 ) {
				if( theName.indexOf( "p_id-"+p_id ) >= 0 ) {
					if( newFlipperValue.length <= 0 ) {
						if( elements[i].style.display == "none" ) { newFlipperValue = "block";
						}else{ newFlipperValue = "none"; }
					}
					elements[i].style.display = newFlipperValue;
				}
			}
		}
	}
}
</script>';
	$output .= $jscode;


	return( $output );
} /* make_flipper_all_callback() */


function filter_flipper_block( $content ) {
	$content =  preg_replace_callback( "/<flipper(\s|>)(.+?)<\/flipper>/s", "make_flipper_callback", $content );
	return( $content );
} /* filter_flipper_block() */

function filter_flipper_block_all( $content ) {
	$content =  preg_replace_callback( "/<flipper_all(.+?)<\/flipper_all>/s", "make_flipper_all_callback", $content );
	return( $content );
} /* filter_flipper_block_all() */


add_filter( 'the_content', 'filter_flipper_block', 12);
add_filter( 'the_content', 'filter_flipper_block_all', 12);

?>